
// This is what *should* be generated by mmx-extend when applied to test.mml

/******************************************************************************
* Instances of gentype are dynamic generic types.
* Instances of generic types have the abstract (pointer) type gentype_inst.
* In order to know which type corresponds to a pointer, a finite number of
* additional classes gentype_inst_1, gentype_inst_2, ... are created,
* such that the dynamic type of an instance of type gentype_inst_nr is
* given by the static variable gentype_cur_nr. These static variables are
* changed in the appropriate way during computations.
******************************************************************************/

struct gentype_rep;
struct gentype_inst;
typedef gentype_rep *gentype;

struct gentype_rep {
  inline gentype_rep () {}
  inline virtual ~gentype_rep () {}
  virtual gentype_inst gen_plus (gentype_inst, gentype_inst);
  virtual gentype_inst gen_minus (gentype_inst, gentype_inst);
  virtual gentype_inst gen_times (gentype_inst, gentype_inst);
  virtual bool gen_equal (gentype_inst, gentype_inst);
};

gentype_inst
gentype_rep::gen_plus (gentype_inst arg_1, gentype_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

gentype_inst
gentype_rep::gen_minus (gentype_inst arg_1, gentype_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

gentype_inst
gentype_rep::gen_times (gentype_inst arg_1, gentype_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

bool
gentype_rep::gen_equal (gentype_inst arg_1, gentype_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

/******************************************************************************
* The gentype_inst type
******************************************************************************/

struct gentype_inst {
  void *rep;
  inline gentype_inst (void *rep2) { rep = rep2; }
  inline ~gentype_inst () {}
};

/******************************************************************************
* The gentype_inst_nr types
******************************************************************************/

static gentype gentype_cur_1;

struct gentype_inst_1 {
  void *rep;
  inline gentype_inst_1 (void *rep2) { rep = rep2; }
  inline ~gentype_inst_1 () {}
};

inline gentype_inst_1
concrete_1 (gentype_inst x) {
  return gentype_inst_1 (x.rep);
}

inline gentype_inst
abstract_1 (gentype_inst_1 x) {
  return gentype_inst (x.rep);
}

gentype_inst_1
operator + (gentype_inst_1 arg_1, gentype_inst_1 arg_2) {
  return concrete_1 (gentype_cur_1->gen_plus (abstract_1 (arg_1), abstract_1 (arg_2)));
}

gentype_inst_1
operator - (gentype_inst_1 arg_1, gentype_inst_1 arg_2) {
  return concrete_1 (gentype_cur_1->gen_minus (abstract_1 (arg_1), abstract_1 (arg_2)));
}

gentype_inst_1
operator * (gentype_inst_1 arg_1, gentype_inst_1 arg_2) {
  return concrete_1 (gentype_cur_1->gen_times (abstract_1 (arg_1), abstract_1 (arg_2)));
}

bool
operator == (gentype_inst_1 arg_1, gentype_inst_1 arg_2) {
  return gentype_cur_1->gen_equal (abstract_1 (arg_1), abstract_1 (arg_2));
}

/******************************************************************************
* The concrete int type
******************************************************************************/

struct gentype_int_rep: gentype_rep {
  inline gentype_int_rep (): gentype_rep () {}
  gentype_inst gen_plus (gentype_inst, gentype_inst);
  gentype_inst gen_minus (gentype_inst, gentype_inst);
  gentype_inst gen_times (gentype_inst, gentype_inst);
};

gentype
gentype_int () {
  return new gentype_int_rep ();
}

gentype_inst
gentype_int_rep::gen_plus (gentype_inst x1, gentype_inst x2) {
  return (gentype_inst) new int ((*((int*) x1)) + (*((int*) x2)));
}

gentype_inst
gentype_int_rep::gen_minus (gentype_inst, gentype_inst) {
  return (gentype_inst) new int ((*((int*) x1)) - (*((int*) x2)));
}

gentype_inst
gentype_int_rep::gen_times (gentype_inst, gentype_inst) {
  return (gentype_inst) new int ((*((int*) x1)) * (*((int*) x2)));
}

/******************************************************************************
* The concrete vector type
******************************************************************************/

struct gentype_vector_rep: gentype_rep {
  gentype T1;
  inline gentype_vector_rep (gentype T1b): gentype_rep (), T1 (T1b) {}
  gentype_inst gen_plus (gentype_inst, gentype_inst);
  gentype_inst gen_minus (gentype_inst, gentype_inst);
  gentype_inst gen_times (gentype_inst, gentype_inst);
};

gentype
gentype_vector (gentype T1) {
  return new gentype_vector_rep (T1);
}

gentype_inst
gentype_vector_rep::gen_plus (gentype_inst x1, gentype_inst x2) {
  gentype save_1= gentype_cur_1;
  gentype_cur_1= T1;
  vector<gentype_inst_1> arg1= *((vector<gentype_inst_1>*) x1);
  vector<gentype_inst_1> arg2= *((vector<gentype_inst_1>*) x2);
  gentype_inst ret= new vector<gentype_inst_1> (arg1 + arg2);
  gentype_cur_1= save_1;
  return ret;
}

gentype_inst
gentype_vector_rep::gen_minus (gentype_inst, gentype_inst) {
  gentype save_1= gentype_cur_1;
  gentype_cur_1= T1;
  vector<gentype_inst_1> arg1= *((vector<gentype_inst_1>*) x1);
  vector<gentype_inst_1> arg2= *((vector<gentype_inst_1>*) x2);
  gentype_inst ret= new vector<gentype_inst_1> (arg1 - arg2);
  gentype_cur_1= save_1;
  return ret;
}
