
/******************************************************************************
* MODULE     : lib_print_tuple.cc
* DESCRIPTION: Printing tuples
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <printer.hh>
namespace mmx {

void
evaluator_rep::lib_print_tuple_1 () {
  CHECK_SYNC (MMX_PRINT_TUPLE);
  // Input: (print_tuple_1, out, vals, type, cont, ...)
  printer out= as_printer (car (rem));
  out->out << "(tuple!";
  cur= LIB_PRINT_TUPLE_2;
  // Output: (print_tuple_2, out, vals, type, cont, ...)
  lib_print_tuple_2 ();
}

void
evaluator_rep::lib_print_tuple_2 () {
  CHECK_SYNC (MMX_PRINT_TUPLE);
  // Input: (print_tuple_2, out, vals, type, cont, ...)
  printer out  = as_printer (car (rem));
  list    vals = as_list (cadr (rem));
  generic type = caddr (rem);
  if (nil (vals)) {
    out->out << ")";
    cur= value (out, ID_OSTREAM);
    rem= cdddr (rem);
    // Output: (cont, out, ...)
    trace= cdr (trace);
  }
  else {
    out->out << " ";
    generic x= value (car (vals), type);
    cur= list (MMX_LESSLESS_STR, value (out, ID_OSTREAM), x);
    rem= cons (LIB_PRINT_TUPLE_3, out, cdr (vals), type, cdddr (rem));
    // Output: (instr, print_tuple_3, out, rem_vals, rem_type, cont, ...)
  }
}

void
evaluator_rep::lib_print_tuple_3 () {
  CHECK_SYNC (MMX_PRINT_TUPLE);
  // Input: (instr, print_tuple_3, out, vals, type, cont, ...)
  cur= LIB_PRINT_TUPLE_2;
  rem= cdr (rem);
  lib_print_tuple_2 ();
}

} // namespace mmx
