
/******************************************************************************
* MODULE     : mmx_extend.cc
* DESCRIPTION: generate generic extension code for C++ template libraries
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <extend.hh>
#include <glue.hh>

using namespace mmx;

int
main (int argc, char** argv) {
  if (argc < 2) { 
    cout << argv[0] << " files\n";
    return 0;
  }

  int i;
  for (i=1; i<argc; i++) {
    string arg = argv[i];
    string root= arg;
    if (ends (root, ".mml")) root= root (0, N(root) - 4);
    string in_name  = root * ".mml";
    string out_name = root * ".mmx.cpp";

    string s;
    insert_source (arg, "cmdline");
    if (load (arg, s)) cerr << "Couldn't open file " << in_name << "\n";
    else  {
      list errors;
      generic prog= parse (s, errors);
      if (!nil (errors)) print_errors (errors);
      else {
	ostream& fout= cout; (void) out_name;
	// fstream fout (as_charp (out_name), std::ios::out);
	extension_code (fout, prog);
      }
    }
  }

  return 0;
}

