
/******************************************************************************
* MODULE     : mmx_glue.cc
* DESCRIPTION: glue for external libraries
* COPYRIGHT  : (C) 2003  Bernard Mourrain
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <glue.hh>

int
main (int argc, char** argv) 
{
  int i;
  mmx::string s;
  if (argc<2) { 
    cout<<argv[0]<<" file"<<std::endl;
    return 0;
  }

  for (i=1; i<argc; i++) {
    mmx::string arg (argv[i]);
    mmx::string name (arg);
    std::fstream  fout(as_charp(arg*".mmx.C"),std::ios::out);
  
    arg = arg *mmx::string(".mml");
    mmx::insert_source (arg, "cmdline");
    //    std::cout << "Parsing file " << arg << "\n";
    if (load (arg, s)) std::cout << "Couldn't open file "<<arg<<"\n";
    else 
      {
	mmx::parse_string (s);
	mmx::list errors;
	mmx::generic output= mmx::parse (s, errors);
	//	std::cout<<">>"<<output<<std::endl;
	mmx::print_errors (errors);
// 	cout << mmx::hrule;
// 	mmx::generic preamble= mmx::car (mmx::cdr (mmx::car (mmx::cdr(output))));
//      mmx::generic local = mmx::car(mmx::cdr(mmx::cdr(preamble)));
//	preamble = mmx::car (mmx::cdr (preamble));
// 	cout<<preamble<<std::endl;
// 	cout<<local<<std::endl;
// 	cout << mmx::hrule;
 	mmx::cpp out(fout);
 	out.init();
// 	cout << "Preamble"<<std::endl;
// 	out.generate(preamble);
// 	cout << "Local"<<std::endl;
	output  =  (mmx::cdr (mmx::car (mmx::cdr(output))));
	out.generate(output);
	mmx::declare link(fout);
	link.init(name);
	link.generate(output);
	link.close(name);
      }
    //    cout << hrule;
  }

  return 0;
}

