
/******************************************************************************
* MODULE     : glue.hh
* DESCRIPTION: glue for external libraries
* COPYRIGHT  : (C) 2003  Bernard Mourrain
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <stdio.h>
#include <iostream>
#include <fstream>
#include <string.h>

#include <single.hh>
#include <list.hh>
#include <literal.hh>
#include <file.hh>
#include <error.hh>
#include <parser.hh>
#include <pretty.hh>
#include <ccpp.hh>
#include <symbols.hh>
#include <parser.hh>

namespace mmx {

  //void init ();
void parse_string (string s);
  //generic generate (std::fstream & fout, generic g);
  //generic link (std::fstream & fout, generic g, string arg= string("tst"));
  //void generate_init(std::fstream & fout);
struct cpp 
{
  std::fstream & fout;
  cpp(std::fstream & out) :fout(out) {}

  void init();
  void generate(generic);
  void instruction (generic v, generic out);
  void include(generic);
  void new_type(generic);
  void new_function(generic);
  void external(generic);
  void function_body(generic w, generic out);
  void mmx_name(generic g);
  void nameoffunction(generic g);
  void namefromsig(generic g);
  void namefromvarsig(generic g);
  void namefromfunctionalsig(generic g);
};

struct ext : public cpp
{
  ext(std::fstream & out): cpp(out) {};
  void generate(generic);
  void new_type(generic);
};

struct declare : public cpp
{
  declare(std::fstream & out): cpp(out) {};
  void generate(generic g);
  void init(string arg = string("tst"));
  void close(string arg = string("tst"));
  void new_type(generic g);
  void new_function(generic g);
  void external(generic);
};
} // namespace mmx
