
/******************************************************************************
* MODULE     : ccpp.hh
* DESCRIPTION: Convert mathemagix trees to C or C++
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __CCPP_HH
#define __CCPP_HH
#include <symbol.hh>
#include <list.hh>
namespace mmx {

void ccpp_print (ostream& out, generic g);

extern symbol CCPP_CONST;
extern symbol CCPP_INLINE;
extern symbol CCPP_STATIC;
extern symbol CCPP_VIRTUAL;

extern symbol CCPP_ARROW;
extern symbol CCPP_CONSTRUCTOR;
extern symbol CCPP_DESTRUCTOR;
extern symbol CCPP_INHERIT;
extern symbol CCPP_SCOPE;
extern symbol CCPP_STRUCT;
extern symbol CCPP_TYPEDEF;
extern symbol CCPP_UNALIAS;
extern symbol CCPP_UNPOINTER;
extern symbol CCPP_UNFUNCTION;
extern symbol CCPP_VERBATIM;

symbol ccpp_name (generic s);
symbol ccpp_opname (generic s);
symbol ccpp_protect (generic s);

inline generic Arrow (generic g1, generic g2) {
  return list (CCPP_ARROW, g1, g2); }
inline generic Constructor (generic g1) {
  return list (CCPP_CONSTRUCTOR, g1); }
inline generic Destructor () {
  return list (CCPP_DESTRUCTOR); }
inline generic Scope (generic g1, generic g2) {
  return list (CCPP_SCOPE, g1, g2); }
inline generic Typedef (generic g1, generic g2) {
  return list (CCPP_TYPEDEF, g1, g2); }

inline generic Const (generic g1) {
  return list (CCPP_CONST, g1); }
inline generic Inline (generic g1) {
  return list (CCPP_INLINE, g1); }
inline generic Static (generic g1) {
  return list (CCPP_STATIC, g1); }
inline generic Virtual (generic g1) {
  return list (CCPP_VIRTUAL, g1); }

}
#endif // __CCPP_HH
